<?php

error_reporting(E_ALL & ~E_NOTICE);

$AudioPath = "/home/pi/Hoerspielland-Play/HLP-Audio";
$FilenameRFIDDatabase = "/home/pi/Hoerspielland-Play/HLP-RFID-Database.txt";
$UDPip = '127.0.0.1';
$UDPport = 9009;

$obj = array();
$antwort = $RFIDs = array();
$getRFIDs = false;

function sendViaUDP($msg)
{
  global $UDPip, $UDPport;

  # Über UDP wird der Befehl an Hoerspielland-Play.py geschickt:

  $sock = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
  $len = strlen($msg);
  socket_sendto($sock, $msg, $len, 0, $UDPip, $UDPport);
  socket_close($sock);
}


if ($_REQUEST["play"]) {
  $id = $_REQUEST["play"];
  sendViaUDP($id);
  sleep(7);
}
else if ($_REQUEST["get"] == "RFIDs") {
  $getRFIDs = true;
}
else if ($_REQUEST["set"] == "down") {
  sendViaUDP('#btnDown');
  sleep(2);
}
else if ($_REQUEST["set"] == "up") {
  sendViaUDP('#btnUp');
  sleep(2);
}
else if ($_REQUEST["set"] == "downHeld") {
  sendViaUDP('#btnDownHeld');
  sleep(5);
}
else if ($_REQUEST["set"] == "upHeld") {
  sendViaUDP('#btnUpHeld');
  sleep(5);
}
else if ($_REQUEST["set"] == "toggle") {
  sendViaUDP('#btnPlay');
  sleep(2);
}
else if ($_REQUEST["set"] == "position") {
  $p = $_REQUEST["percent"] * 1;
  // Spotify oder Datei?
  $antwort = shell_exec(escapeshellcmd("mpc -f \"%time%__%file%__%artist%__%album%\" playlist"));
  trim($antwort);
  $zeilen = explode("\n", $antwort);
  if (count($zeilen) > 1)
  {
    // Hörspiel besteht aus mehreren MP3-Dateien!
    $TrackSekunden = array();
    $AlbumSekunden = 0;
    $PositionSekunden = 0;
    $PositionGefunden = false;
    foreach($zeilen as $key => $zeile)
    {
      if ($zeile)
      {
        list($zeit, $TrackFile, $Serie, $Folge) = explode("__", $zeile);
        list($m, $s) = explode(":", $zeit);
        $Sekunden = ($m*60) + ($s*1);
        $TrackSekunden[] = $Sekunden;
        $AlbumSekunden += $Sekunden;
      }  
    }
    $ProzentSekunden = round($AlbumSekunden * $p / 100, 0);
    foreach($TrackSekunden as $TrackNr => $Sekunden)
    {
      if ($ProzentSekunden < $Sekunden)
      {
        $antwort = shell_exec(escapeshellcmd("mpc play ".($TrackNr+1)));
        $p = round($ProzentSekunden * 100 / $Sekunden, 0);
        break;
      }
      else
        $ProzentSekunden -= $Sekunden;
    }
  } else {
    // Hörspiel besteht aus einer MP3-Dateien!
  }
  sleep(1);
  $antwort = shell_exec(escapeshellcmd("mpc seek $p%"));
  sleep(1);
}
else if ($_REQUEST["set"] == "add") {
  $antwort = shell_exec(escapeshellcmd("mpc add ''"));
}
else if ($_REQUEST["edit"]) {
  $antwort = file_get_contents($FilenameRFIDDatabase);
  $RFIDs = json_decode($antwort, true);
  $RFIDs[$_REQUEST["id"]] = array();
  $RFIDs[$_REQUEST["id"]]["PlayMode"] = $_REQUEST["PlayMode"];
  $RFIDs[$_REQUEST["id"]]["PlayName"] = $_REQUEST["PlayName"];
  $erfolg = file_put_contents($FilenameRFIDDatabase, json_encode($RFIDs));
  if ($erfolg === false)
     $obj["Message"] = "Keine Änderung möglich: evtl. Permission denied für die RFID-Datei. Lösung: 'chmod o+w /home/pi/Hoerspielland-Play/HLP-RFID-Database.txt'";
  $getRFIDs = true;
}
else if ($_REQUEST["delete"]) {
  $antwort = file_get_contents($FilenameRFIDDatabase);
  $RFIDs = json_decode($antwort, true);
  unset($RFIDs[$_REQUEST["delete"]]);
  $erfolg = file_put_contents($FilenameRFIDDatabase, json_encode($RFIDs));
  if ($erfolg === false)
     $obj["Message"] = "Kein Löschen möglich: evtl. Permission denied für die RFID-Datei. Lösung: 'chmod o+w /home/pi/Hoerspielland-Play/HLP-RFID-Database.txt'";
  $getRFIDs = true;
}
else if ($_REQUEST["hlp-direct"])
{
  sendViaUDP($_REQUEST["PlayName"]);
  sleep(7);
}

if ($getRFIDs)
{
  $antwort = file_get_contents($FilenameRFIDDatabase);
  $t = json_decode($antwort, true);
  $obj["RFID"] = $t;
}


// Status ermitteln

$antwort = shell_exec(escapeshellcmd("mpc -f \"%file%\""));

// Lautstärke und Status ermitteln
if (preg_match("/volume: *(\d+)%/s", $antwort, $match))
  $vol = $match[1];
else
  $vol = '-';
$obj["Player"]["Volume"] = $vol;

if (preg_match("/\[paused\]/s", $antwort, $match))
  $obj["Player"]["PlayStatus"] = "paused";
else if (preg_match("/\[playing\]/s", $antwort, $match))
  $obj["Player"]["PlayStatus"] = "playing";

// Aktuell abgespielte MP3 ermitteln
// Aktuelle Position beim Abspielen
/*
file:///home/pi/Hoerspielland-Play/HLP-Audio/Sherlock Holmes/004.mp3
[paused]  #1/1   0:06/70:25 (0%)
volume:100%   repeat: off   random: off   single: off   consume: off
*/
$obj["Player"]["Current"]["Serie"] = "";
$obj["Player"]["Current"]["Folge"] = "";
$obj["Player"]["Current"]["Position"] = "";
$obj["Player"]["Current"]["PositionPercent"] = "";
$obj["Player"]["Current"]["Duration"] = "";
if (preg_match("/(\d+:\d+)\/(\d+:\d+)/s", $antwort, $match)) {
  $obj["Player"]["Current"]["Position"] = $match[1];
  $obj["Player"]["Current"]["Duration"] = $match[2];
}
if (preg_match("/\((\d+%)\)/s", $antwort, $match)) {
  $obj["Player"]["Current"]["PositionPercent"] = " ".$match[1];
}

// Besteht das Hörspiel aus mehreren Tracks?
if (preg_match("/#(\d+)\/(\d+)/s", $antwort, $match))
{
  if ($match[2] > 1)
  {
    // Das Hörspiel besteht aus mehreren Tracks. Ein Spotify-Hörspiel besteht fast immer aus mehreren Tracks.
    // Die Gesamtlänge des Hörspiels ermitteln:
    // Bei einem Spotify-Hörspiel den Seriennamen und die Folge aus %artist% und %album% lesen
    // Bei einem File-Hörspiel stammen diese Daten aus dem ID3-Tag.

    $CurrentTrackID = $match[1];

    $antwort = shell_exec(escapeshellcmd("mpc -f \"%time%__%file%__%artist%__%album%\" playlist"));
    $zeilen = explode("\n", $antwort);
    $TrackSekunden = array();
    $AlbumSekunden = 0;
    $PositionSekunden = 0;
    $PositionGefunden = false;
    foreach($zeilen as $key => $zeile)
    {
      if ($zeile)
      {
        list($zeit, $TrackFile, $Serie, $Folge) = explode("__", $zeile);
      
        $obj["Player"]["Current"]["Serie"] = $Serie;
        $obj["Player"]["Current"]["Folge"] = $Folge;

        $TrackFile = trim($TrackFile);
        $zeit = trim($zeit);
        list($m, $s) = explode(":", $zeit);
        $Sekunden = ($m*60) + ($s*1);
        $TrackSekunden[] = $Sekunden;
        $AlbumSekunden += $Sekunden;

        if (!$PositionGefunden)
        {
          if ($key+1 < $CurrentTrackID)
            $PositionSekunden += $Sekunden;
          else
          {
            list($m, $s) = explode(":", $obj["Player"]["Current"]["Position"]);
            $ActTrackPosition = ($m*60) + ($s*1);
            $PositionSekunden += $ActTrackPosition;
            $PositionGefunden = true;
          }  
        }
      }
    }

    $AlbumSekundenStr = $AlbumSekunden % 60;
    if ($AlbumSekundenStr < 10)
      $AlbumSekundenStr = "0".$AlbumSekundenStr;
    else
      $AlbumSekundenStr = $AlbumSekundenStr."";
    $obj["Player"]["Current"]["Duration"] = floor($AlbumSekunden / 60).":".$AlbumSekundenStr;
    
    $PositionSekundenStr = $PositionSekunden % 60;
    if ($PositionSekundenStr < 10)
      $PositionSekundenStr = "0".$PositionSekundenStr;
    else
      $PositionSekundenStr = $PositionSekundenStr."";
    $obj["Player"]["Current"]["Position"] = floor($PositionSekunden / 60).":".$PositionSekundenStr;

    $obj["Player"]["Current"]["PositionPercent"] = round($PositionSekunden * 100 / $AlbumSekunden, 0)."%";
  }
}
if (preg_match("/file:\/\/(.+)/", $antwort, $match))
{
  // Der Serienname und die Folge werden bei Dateien aus dem Dateinamen entnommen und nicht aus dem ID3-Tag
  $CurDirname = $match[1];
  list($dummy, $HspFile) = explode("HLP-Audio/", $CurDirname);
  list($Serie, $Folge) = explode("/", $HspFile);
  $t = explode(".", $Folge);
  if (count($t) > 1)
    array_pop($t);
  $Folge = implode("", $t);
  $Serie = trim($Serie);
  $Folge = trim($Folge);
  $obj["Player"]["Current"]["Serie"] = $Serie;
  $obj["Player"]["Current"]["Folge"] = $Folge;
}

$obj["Player"]["Current"]["CoverURL"] = "";
$obj["Player"]["Current"]["CoverLink"] = "";
if ($Serie || $Folge)
{
  if ($obj["Player"]["PlayStatus"] == "paused" || $obj["Player"]["PlayStatus"] == "playing")
  {
    // Link zu Hörspielland und Cover ermitteln
    $HlpCover = file_get_contents("http://www.hoerspielland.de/hlp-cover.php?search=".urlencode($Serie." ".$Folge)."&hlT=json");
    $HlpCover = json_decode($HlpCover, true);
    $obj["Player"]["Current"]["CoverURL"] = $HlpCover["CoverURL"];
    $obj["Player"]["Current"]["CoverLink"] = $HlpCover["CoverLink"];
  }
}


if ($_REQUEST["hlp-direct"] || $_REQUEST["edit"] == "hlp-spotify")
{
  // Redirect auf index.php
  virtual("index.php");
} else {
  echo json_encode($obj);
}

?>