var xmlHttpObject = false;

if (typeof XMLHttpRequest != 'undefined') 
{
  xmlHttpObject = new XMLHttpRequest();
}
if (!xmlHttpObject) 
{
  try 
  {
    xmlHttpObject = new ActiveXObject("Msxml2.XMLHTTP");
  }
  catch(e) 
  {
    try 
    {
      xmlHttpObject = new ActiveXObject("Microsoft.XMLHTTP");
    }
    catch(e) 
    {
      xmlHttpObject = null;
    }
  }
}

function hlpLoadRFIDs()
{
  xmlHttpObject.open('get','hlp-control.php?get=RFIDs');
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(null);
  return false;
}

function hlpControl(action)
{
  if (action == 'downHeld' || action == 'upHeld')
    showLoadingWall();

  xmlHttpObject.open('get','hlp-control.php?set=' + action);
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(null);
  return false;
}

var hlpEditPlayMode = 1;

function hlpEditMode(m)
{
  if (!m) {
    m = 1;
  }
  hlpEditPlayMode = m;
  for(i = 1; i <= 3; i++) {
    document.getElementById('hlpPlayMode' + i.toString()).style.borderColor = 'transparent';
  }
  document.getElementById('hlpPlayMode' + hlpEditPlayMode.toString()).style.borderColor = 'red';
  return false;
}

function hlpEditSave()
{
  var data = new FormData();
  data.append('id', document.getElementById('hlpEditID').innerHTML);
  data.append('PlayMode', hlpEditPlayMode.toString());
  data.append('PlayName', document.getElementById('hlpEditPlayName').value);

  xmlHttpObject.open('post', 'hlp-control.php?edit=true', true);
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(data);

  hideEdit();

  return false;
}

function editDelete()
{
  id = document.getElementById('hlpEditID').innerHTML;
  xmlHttpObject.open('get','hlp-control.php?delete=' + id);
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(null);

  hideEdit();

  return false;
}

function playCard(id)
{
  showLoadingWall();

  xmlHttpObject.open('get','hlp-control.php?play=' + id);
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(null);

  return false;
}

var rowCount = 0;

function handleContent()
{
  if (xmlHttpObject.readyState == 4)
  {
    var antwort = xmlHttpObject.responseText;
    console.log(antwort);
    hideLoadingWall();

    var obj = JSON.parse(xmlHttpObject.responseText);
    
    if (obj["Player"]) {
      if (obj["Player"]["PlayStatus"] == 'playing') {
        document.getElementById('btnPlay').src = "pic/hlp-btn-pause.png";
      }
      else if (obj["Player"]["PlayStatus"] == 'paused') {
        document.getElementById('btnPlay').src = "pic/hlp-btn-play.png";
      }
      if (obj["Player"]["Volume"]) {
        document.getElementById('Volume').innerHTML = obj["Player"]["Volume"] + " %";
      }
      if (obj["Player"]["Current"]["CoverLink"]) {
        if (obj["Player"]["Current"]["CoverURL"]) {
          document.getElementById('hlCoverFB').href = obj["Player"]["Current"]["CoverURL"];
          document.getElementById('hlCoverImg').src = obj["Player"]["Current"]["CoverURL"];
          document.getElementById('hlCoverImg').style.display = '';
        } else {
          document.getElementById('hlCoverImg').style.display = 'none';
        }
        document.getElementById('hlCoverLink').href = obj["Player"]["Current"]["CoverLink"];
        document.getElementById('hlCover').style.display = '';
      }
      else
        document.getElementById('hlCover').style.display = 'none';
      var plPosition = "&nbsp;";
      var plPositionPercent = "&nbsp;";
      var plDuration = "&nbsp;";
      var plSerie = "&nbsp;";
      var plFolge = "&nbsp;";
      if (obj["Player"]["Current"]) {
        if (obj["Player"]["Current"]["Position"]) plPosition = obj["Player"]["Current"]["Position"];
        if (obj["Player"]["Current"]["PositionPercent"]) {
          plPositionPercent = obj["Player"]["Current"]["PositionPercent"];
          document.getElementById('PlayerBarL').setAttribute('width', plPositionPercent);
        }
        if (obj["Player"]["Current"]["Duration"]) plDuration = obj["Player"]["Current"]["Duration"];
        if (obj["Player"]["Current"]["Serie"]) plSerie = obj["Player"]["Current"]["Serie"];
        if (obj["Player"]["Current"]["Folge"]) plFolge = obj["Player"]["Current"]["Folge"];
      }
      document.getElementById('PlayerSerie').innerHTML = plSerie;
      document.getElementById('PlayerFolge').innerHTML = plFolge;
      document.getElementById('PlayerPosition').innerHTML = plPosition;
      document.getElementById('PlayerPositionPercent').innerHTML = plPositionPercent;
      document.getElementById('PlayerDuration').innerHTML = plDuration;

      if (false && plFolge != "") {
        var s = plSerie + " " + plFolge;
        var hlT = "http://www.hoerspielland.de/hlp-cover.php?search=" + encodeURI(s);
        document.getElementById('hlpBody').style.backgroundImage = "linear-gradient(to right, transparent 0%, white 30%, white 70%,transparent 100%), url('" + u + "')";
      } else {
        document.getElementById('hlpBody').style.backgroundImage = "";
      }
    }

    if (obj["RFID"]) {
      var table = document.getElementById("RFIDtab");

      for(i = 1; i <= rowCount; i++)
      {
        ele = document.getElementById('Card_' + i.toString());
        ele.parentNode.removeChild(ele);
        console.log('Zeile ' + i.toString() + ' gelöscht.');
      }
      rowCount = 0;

      ele = document.getElementById("RFIDtabRow");
      for (let id in obj["RFID"]) {
        rowCount++;
        newNode = ele.cloneNode(true);
        newNode.id = "Card_" + rowCount.toString();
        newNode.style.display = '';
        ele.parentNode.appendChild(newNode);

        elePCs = document.getElementsByName('PlayCard');
        elePC = elePCs[1];
        elePC.setAttribute("name", "PlayCard_" + rowCount.toString());
        elePC.setAttribute("onClick", "playCard('" + id + "'); return false;");

        elePMs = document.getElementsByName('PlayMode');
        elePM = elePMs[1];
        elePM.setAttribute("name", "PlayMode_" + rowCount.toString());
        if (obj["RFID"][id]["PlayMode"] == 1) {
          elePM.src = "pic/hlp-btn-shuffle.png";
          elePM.title = "Hörspiel-Modus: Ein zufälliges Hörspiel aus dem Verzeichnis abspielen."
        } else if (obj["RFID"][id]["PlayMode"] == 2) {
          elePM.src = "pic/hlp-btn-audiobook.png";
          elePM.title = "Audiobook-Modus: Alle Dateien im Verzeichnis der Reihe nach abspielen und den Fortschritt speichern."
        } else if (obj["RFID"][id]["PlayMode"] == 3) {
          elePM.src = "pic/hlp-btn-file.png";
          elePM.title = "Datei-Modus: Die angegebene Datei abspielen."
        } else {
          elePM.src = "pic/hlp-btn-pixel.gif";
          elePM.title = "";
        }
        elePM.alt = obj["RFID"][id]["PlayMode"];

        eleIDs = document.getElementsByName('id');
        eleID = eleIDs[1];
        eleID.setAttribute("name", "id_" + rowCount.toString());
        eleID.innerHTML = id;

        elePNs = document.getElementsByName('PlayName');
        elePN = elePNs[1];
        elePN.setAttribute("name", "PlayName_" + rowCount.toString());
        elePN.innerHTML = obj["RFID"][id]["PlayName"];

        eleBEs = document.getElementsByName('btnEdit');
        eleBE = eleBEs[1];
        eleBE.setAttribute("name", "btnEdit_" + rowCount.toString());
        eleBE.setAttribute("onClick", "showEdit('" + rowCount.toString() + "'); return false;");
      }
    }
  }
}

function hlpSetPosition(e) {
  var ele = document.getElementById('PlayerPositionBar');
  var domRect = ele.getBoundingClientRect();

  x = e.pageX - domRect.left; 
  y = e.pageY - domRect.top; 
  w = domRect.width;
  p = Math.round(x * 100 / w);

  xmlHttpObject.open('get','hlp-control.php?set=position&percent=' + p.toString());
  xmlHttpObject.onreadystatechange = handleContent;
  xmlHttpObject.send(null);
}

function showEdit(nr)
{
  var rfid = document.getElementsByName('id_' + nr)[0].innerHTML;
  document.getElementById('hlpEditID').innerHTML = rfid;
  document.getElementById('hlpEditPlayName').value = document.getElementsByName('PlayName_' + nr)[0].innerHTML;
  document.getElementById('hlpSpotifyHLlink').href = "http://www.hoerspielland.de/index.php?r=1.0.1&hlp=spotify&hlp_rfid=" + encodeURI(rfid) + "&hlp_ip=" + encodeURI(window.location.hostname) + "";
  hlpEditMode(document.getElementsByName('PlayMode_' + nr)[0].alt);
  document.getElementById('editDiv').style.display = '';
  document.getElementById('hlpEditPlayName').focus();

  return false;
}

function hideEdit()
{
  document.getElementById('editDiv').style.display = 'none';
  return false;
}

window.addEventListener("message", function(event) {
  if(event.data === 'showHlpLink') {
    document.getElementById('hlFrame').style.height = "110px";
  } else {
    document.getElementById('hlFrame').style.height = "0px";
  }
})

function shuffle(a) {
  var j, x, i;
  for (i = a.length - 1; i > 0; i--) {
      j = Math.floor(Math.random() * (i + 1));
      x = a[i];
      a[i] = a[j];
      a[j] = x;
  }
  return a;
}

var loadingImgArr = [1,2,3,4,5,6,7];
shuffle(loadingImgArr);
var loadingImgNr = -1;

function showLoadingWall()
{
  loadingImgNr++;
  if (loadingImgNr >= loadingImgArr.length)
    loadingImgNr = 0;

  for(i = 1; i <= loadingImgArr.length; i++)
  {
    if (i == loadingImgArr[loadingImgNr])
      document.getElementById('loadingImg' + i).style.display = '';
    else
      document.getElementById('loadingImg' + i).style.display = 'none';
  }
  document.getElementById('loadingWall').style.display = '';
}
function hideLoadingWall()
{
  document.getElementById('loadingWall').style.display = 'none';
}